  
  // include the file Trade.mqh
#include<Trade\Trade.mqh>

// Create an instance of Ctrade
CTrade trade;

//--- available trailing
#include <Expert\Trailing\TrailingNone.mqh>
//--- available money management
#include <Expert\Money\MoneyFixedLot.mqh>
//+------------------------------------------------------------------+
//| Inputs                                                           |
//+------------------------------------------------------------------+

//--- inputs for main signal
input double             Take_Pofit             =800.0;         //Take Profit in pips
input double             Stop_Loss            =300.0;          //Stop Loss

//--- inputs for money
input double             Money_FixLot_Percent =1.0;        // Percent per trade
input double             Money_FixLot_Lots    =0.10;         // Fixed volume per trade
//+------------------------------------------------------------------+
//| Global expert object                                             |
//+------------------------------------------------------------------+


//CExpert ExtExpert;
//+------------------------------------------------------------------+
//| Initialization function of the expert                            |
//+------------------------------------------------------------------+


void OnTick()
  {
      // create Array for several prices
      double myMovingAverageArray1[], myMovingAverageArray2[];
      
      // define the properties of the Moving Average 1
      int movingAverageDefinition1 = iMA (_Symbol,_Period,200,0,MODE_SMA,PRICE_CLOSE);
      
      // define the properties of the Moving Average 2
       int movingAverageDefinition2 = iMA (_Symbol,_Period,200,0,MODE_SMA,PRICE_CLOSE);
       
       // sort the price array from the current candle downwards
       ArraySetAsSeries(myMovingAverageArray1,true);
       
         // sort the price array from the current candle downwards
       ArraySetAsSeries(myMovingAverageArray2,true);     
       
       // Defined MA1, one line, current candle, 3 candles, store result
       CopyBuffer(movingAverageDefinition1,0,0,3,myMovingAverageArray1);
       
       // Defined MA2, one line, current candle, 3 candles, store result
       CopyBuffer(movingAverageDefinition2,0,0,3,myMovingAverageArray2);
  
  {
      Comment (""); //empty chart output
      
      // create an Array for several prices
      double myPriceArray0[];
      
      // create an Array for several prices (create 2 b/c the indicator has 2 functions)
      double myPriceArray1[];
      
      // define the propertives of the RVI EA...this is where to change the period
      int RVIDefintion = iRVI(_Symbol,_Period,386);
      
      // sort the price arra from the current candle downwards
      ArraySetAsSeries(myPriceArray0,true);
      
          // sort the price arra from the current candle downwards
      ArraySetAsSeries(myPriceArray1,true);
   
      //Defined MA0, first line, current candle, 3 candles, store result
      CopyBuffer(RVIDefintion,0,0,3,myPriceArray0);
      
       //Defined MA0, second line, current candle, 3 candles, store result
      CopyBuffer(RVIDefintion,1,0,3,myPriceArray1); 
      
       //Get the value for the current candle
       double RVIValue0=(NormalizeDouble(myPriceArray0[0],3));
       
       //Get the value for the current candle
       double RVIValue1=(NormalizeDouble(myPriceArray1[0],3));  
       

  
   // Get the ask price
   double Ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
   
   //Get the bid price
   
      double Bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
    
    
      //Create an Array for prices
      MqlRates PriceInformation[];
      
      
      // Sort it from current candle to oldest candle
      ArraySetAsSeries(PriceInformation,true);
      
      //Copy price data into the array ------ old text that was in place of 50 --- Bars(Symbol(),Period())
      int Data=CopyRates(Symbol(),Period(),0,50,PriceInformation);
   
   
   //--- variables for returning values from position properties

   double   open_price;
   double   initial_volume;
   long     positionID;
   double   position_profit;
           static double Greatest_SL;
          ulong PositionTicket;  
   int PositionDirection;
   
   
  // int      buy;
  // int     sell;

   ENUM_POSITION_TYPE      type;

//--- number of current positions

   uint     total=PositionsTotal();
//--- go through orders in a loop
   for(uint i=0;i<total;i++)
     
      //--- return order ticket by its position in the list
      if(PositionSelect(_Symbol)==true)
        {
         //--- return order properties
         open_price    =PositionGetDouble(POSITION_PRICE_OPEN);
         positionID    =PositionGetInteger(POSITION_IDENTIFIER);
         initial_volume=PositionGetDouble(POSITION_VOLUME);
         position_profit=PositionGetDouble(POSITION_PROFIT);
         
       //  buy            =PositionGetInteger(POSITION_TYPE_BUY);
        // sell           =PositionGetInteger(POSITION_TYPE_SELL);
        
                                // Get the positon direction
         int PositionDirection=PositionGetInteger(POSITION_TYPE);
         
         type          =(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
 }
   

        

      // set the desired Stop Loss to 150 Points
      double Buy_SL=NormalizeDouble(Ask-Stop_Loss*_Point,_Digits);
      
      //Create high ask price since open
      static double High_Since_Open;
 
  int Buy_Position_Counter=0;
  int Sell_Position_Counter=0;   

      
      //check all open positions for the current symbol
      for(int i=PositionsTotal()-1; i>=0; i--) // count all currency pair positions
      {
         string symbol=PositionGetSymbol(i); // get position symbol
            if(_Symbol==symbol) // if chart symbol equals position symbol
            {
               // get the ticket number
              PositionTicket=PositionGetInteger(POSITION_TICKET); 
               
                     //get open price
                double open_price=PositionGetDouble(POSITION_PRICE_OPEN);  
               
               //get the current Stop Loss
               double CurrentStopLoss=PositionGetDouble(POSITION_SL);
               
                        // Get the positon direction
         PositionDirection=PositionGetInteger(POSITION_TYPE);
         
                  //if it is a buy position
         if (PositionDirection==POSITION_TYPE_BUY)
         
         //close the current position add to buy counter here
               // add 1 to the candleCounter
      Buy_Position_Counter=Buy_Position_Counter+1;
      
               //if it is a buy position
         if (PositionDirection==POSITION_TYPE_SELL)
         
         //close the current position add to buy counter here
               // add 1 to the candleCounter
      Sell_Position_Counter=Sell_Position_Counter+1;
         
         //if it is a buy position
         if (PositionDirection==POSITION_TYPE_BUY)
            if(PositionsTotal()>=1 && Ask>High_Since_Open)  
              
         
        {
        High_Since_Open=Ask;
        }
        else if (PositionsTotal()<=0)
        {
        High_Since_Open=0.0;
        }
        

        
      Greatest_SL=High_Since_Open-open_price;
        

  
             } // End of symbold if loop
            
         } // End for loop
         
   //+++++++++++++++++++++++++++++ trailing bid code +++++++++++++
   
   
   
      // set the desired Stop Loss to 150 Points
      double Sell_SL=NormalizeDouble(Bid+Stop_Loss*_Point,_Digits);
      
      //Create high ask price since open
      static double Low_Since_Open;
      
      double Lowest_SL;
   
      
      //check all open positions for the current symbol
      for(int i=PositionsTotal()-1; i>=0; i--) // count all currency pair positions
      {
         string symbol=PositionGetSymbol(i); // get position symbol
            if(_Symbol==symbol) // if chart symbol equals position symbol
            {

               
                     //get open price
                double open_price=PositionGetDouble(POSITION_PRICE_OPEN);  
               
               //get the current Stop Loss
               double CurrentStopLoss=PositionGetDouble(POSITION_SL);
               
                        // Get the positon direction
         PositionDirection=PositionGetInteger(POSITION_TYPE);
         
         //if it is a buy position
         if (PositionDirection==POSITION_TYPE_SELL)
            if(Bid != 0.0)
            if(PositionsTotal()>=1 && Bid<Low_Since_Open)  
                
         
        {
        Low_Since_Open=Bid;
        }
        else if (PositionsTotal()<=0)
        {
        Low_Since_Open=Bid;
        }
        
        static double Lowest_SL;
        
      Lowest_SL=open_price-Low_Since_Open;

            } // End of symbold if loop
            
         } // End for loop
   //+++++++++++++++++++++++++++New Low SL Calculation
   
   static double Greatest_Sell_SL;
   
            if (PositionDirection==POSITION_TYPE_SELL)
            if(PositionsTotal()>=1 && (open_price-Bid>Greatest_Sell_SL)) 
      {
      Greatest_Sell_SL=open_price-Bid;
      }
      else
      {
      Greatest_Sell_SL=0.0;
      }
   
   
   
   //++++++++++++++++
 
    if (Buy_Position_Counter<1 && (OrdersTotal()+PositionsTotal())==PositionsTotal()) 
    //  if (PriceInformation[0].high>myMovingAverageArray1[0])
     //    if(PriceInformation[1].high<myMovingAverageArray1[0])

     //   if(myPriceArray0[0]>myPriceArray0[1])
     if(Ask<=myMovingAverageArray1[0]+(5*_Point) && Ask>=myMovingAverageArray1[0]-(2*_Point))
      {trade.Buy(Money_FixLot_Percent,NULL,Ask,(Ask-Stop_Loss*_Point),(Ask+Take_Pofit*_Point),NULL);}
    //  

     if (Sell_Position_Counter<1 && (OrdersTotal()+PositionsTotal())==PositionsTotal())  
         //  if (PriceInformation[0].low<myMovingAverageArray1[0])
       //  if(PriceInformation[1].low>myMovingAverageArray1[0])
     
        
     //   if(myPriceArray0[0]<myPriceArray0[1])
       if(Bid>=myMovingAverageArray1[0]-(5*_Point) && Bid<=myMovingAverageArray1[0]+(2*_Point))
      {trade.Sell(Money_FixLot_Percent,NULL,Bid,(Bid+Stop_Loss*_Point),(Bid-Take_Pofit*_Point),NULL);}
      
  // 
   
   // Call the Trailing Stop Module
   CheckTrailingStop(Ask, myMovingAverageArray1, movingAverageDefinition1, Buy_SL, High_Since_Open, PositionDirection, Greatest_SL, PositionTicket, open_price);
   CheckSellStop(Bid, myMovingAverageArray1, movingAverageDefinition1, Sell_SL, Low_Since_Open, PositionDirection, Lowest_SL, PositionTicket, open_price, Greatest_Sell_SL);
 
 
 } 
 
 
 
 
 
 } //End of the OnTick function


void CheckTrailingStop(double Ask, double &myMovingAverageArray1[], int movingAverageDefinition1, double Buy_SL, double High_Since_Open, int PositionDirection,double Greatest_SL, ulong PositionTicket, double open_price)
   {

               
               // If current Stop Loss is below 26 points from Ask price
               if (Greatest_SL>(Stop_Loss*_Point))
               {
               //Modify the Stop Loss by 10 points
               trade.PositionModify(PositionTicket,(myMovingAverageArray1[0]),open_price+Take_Pofit*_Point);
               }

      } // End Trailing Stop function
               
               

void CheckSellStop(double Bid, double &myMovingAverageArray1[], int movingAverageDefinition1, double Sell_SL, double Low_Since_Open, int PositionDirection, double Lowest_SL, ulong PositionTicket, double open_price, double Greatest_Sell_SL)
   {
       

      
               
               // If current Stop Loss is below 26 points from Ask price
               if (Greatest_Sell_SL>(Stop_Loss*_Point))
               {
               //Modify the Stop Loss by 10 points
               trade.PositionModify(PositionTicket,(myMovingAverageArray1[0]),open_price-Take_Pofit*_Point);
               }

         
      } // End Trailing Stop function
               